/**
 * UGENE - Integrated Bioinformatics Tools.
 * Copyright (C) 2008-2025 UniPro <ugene@unipro.ru>
 * http://ugene.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#pragma once

#include "ui_QueryEditorWidget.h"

namespace U2 {

class Descriptor;
class QueryProcCfgModel;
class QDParameters;
class QDActor;
class QDConstraint;
class QueryViewController;
class ProcessNameValidator;
class QDActorPrototype;

class QueryEditor : public QWidget, public Ui_QueryEditorWidget {
    Q_OBJECT
    friend class ProcessNameValidator;

public:
    QueryEditor(QWidget* parent = 0);
    void showProto(QDActorPrototype* proto);
    void edit(QDConstraint* constraint);
    void edit(QDActor* a);
    void reset();
    void setCurrentAttribute(const QString& id);
private slots:
    void sl_showPropDoc();
    void sl_setLabel();
    void sl_setKey();
    void sl_setDirection(int);
signals:
    void modified();

private:
    void setDescriptor(const Descriptor* d, const QString& hint = QString());

    QueryProcCfgModel* cfgModel;
    QDActor* current;
};

}  // namespace U2
